---
title: TypedArray.prototype.set()
slug: Web/JavaScript/Reference/Global_Objects/TypedArray/set
tags:
  - JavaScript
  - Method
  - Prototype
  - Reference
  - TypedArray
---
<div>{{JSRef}}</div>

<p>The <strong><code>set()</code></strong> method stores multiple values in the typed array, reading input values from a specified array.</p>

<div>{{EmbedInteractiveExample("pages/js/typedarray-set.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>typedarray</var>.set(<var>array</var>[, <var>offset</var>])
<var>typedarray</var>.set(<var>typedarray</var>[, <var>offset</var>])
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>array</var></code></dt>
 <dd>The array from which to copy values. All values from the source array are copied into the target array, unless the length of the source array plus the offset exceeds the length of the target array, in which case an exception is thrown.</dd>
 <dt><code><var>typedarray</var></code></dt>
 <dd>If the source array is a typed array, the two arrays may share the same underlying {{jsxref("ArrayBuffer")}}; the JavaScript engine will intelligently <strong>copy</strong> the source range of the buffer to the destination range.</dd>
 <dt><code><var>offset</var></code> {{optional_inline}}</dt>
 <dd>The offset into the target array at which to begin writing values from the source array. If this value is omitted, 0 is assumed (that is, the source array will overwrite values in the target array starting at index 0).</dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<p>A {{jsxref("RangeError")}}, if the <code>offset</code> is set such as it would store beyond the end of the typed array.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_set">Using set()</h3>

<pre class="brush:js">var buffer = new ArrayBuffer(8);
var uint8 = new Uint8Array(buffer);

uint8.set([1, 2, 3], 3);

console.log(uint8); // Uint8Array [ 0, 0, 0, 1, 2, 3, 0, 0 ]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-%typedarray%.prototype.set-array-offset', 'TypedArray.prototype.set')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.TypedArray.set")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Typed_arrays">JavaScript typed arrays</a></li>
 <li>{{jsxref("TypedArray")}}</li>
 <li>{{jsxref("ArrayBuffer")}}</li>
</ul>
